/*
 * RT-Linux FIFOs
 *
 *  Copyright (C) 1999 VJY Associates LLC (http://www.fsmlabs.com/)
 *  Written by Michael Barabanov <baraban@fsmlabs.com>
 */

#ifndef __RTF__
#define __RTF__

#define RTF_NO 64
#define RTL_MAX_USER_FIFO RTF_NO

#define RTF_MAX_FIFO (RTL_MAX_USER_FIFO + 8)

#ifdef __KERNEL__

extern int rtf_init(void);

extern int rtf_create_handler(unsigned int fifo, int (*handler)(unsigned int fifo));


typedef int (*rtl_fifo_handler_t)(unsigned int fifo);

/* rtf_put and rtf_get handlers */
extern int rtf_setwritehandler (unsigned int fifo, rtl_fifo_handler_t handler, rtl_fifo_handler_t *oldhandler);
extern int rtf_setreadhandler (unsigned int fifo, rtl_fifo_handler_t handler, rtl_fifo_handler_t *oldhandler);



extern int rtf_create(unsigned int fifo, int size);

extern int rtf_destroy(unsigned int fifo);

extern int rtf_resize(unsigned int minor, int size);

extern int rtf_put(unsigned int fifo, void * buf, int count);

extern int rtf_get(unsigned int fifo, void * buf, int count);

#endif

#endif
